///////////////////////////////
/////     qsort_sq1.h      ////////
///////////////////////////////

#if !defined QSORT_SP1_H
#define      QSORT_SP1_H

#include <iostream>
#include <cstdlib>
#include "name_and_value.h"

using namespace std ;

template <>
class QuickSort < NameAndValue > {
		//----- mode of comparinig function
		//.....  mode = 0:  use compare0()
		//.....       = 1:  use compare1()
	int	mode ;

 public:
		//----- constructor
	QuickSort( int mode_given = 0 ) { setMode ( mode_given ); }

		//----- destructor
	~QuickSort() {;}

		//----- set mode
	void	setMode( int mode_given = 0 ) { mode = mode_given ; }

		//----- get mode at present
	int	getMode() { return mode ; }

		//----- quick sort function
	void doSort( NameAndValue* a, int left, int right ) 
	{
	  //----- local variables
	  int	i, j ;
	  NameAndValue	axis, tmp ;

	  //-----  axis
	  axis = a [ (left + right ) /2 ] ; 

	  //----- starting i and j
	  i = left ;	j = right ;

	  while(1) {
	    if        ( mode == 0 ) { 
	      while ( compare0( &a[ i ] , &axis ) == -1 ) { i++ ; }
	      while ( compare0( &a[ j ],  &axis ) == +1 ) { j-- ; }
	    } else if ( mode == 1 ) { 
	      while ( compare1( &a[ i ] , &axis ) == -1 ) { i++ ; }
	      while ( compare1( &a[ j ],  &axis ) == +1 ) { j-- ; }
	    } else {
	      cerr << "ERROR ( QuickSort::doSort() )\n";
	      cerr << "     mode = " << mode << endl ;
	      exit(1) ;
	    }

	    //----- termination condition
	    if( i >= j ) { 	break ; }

	    //----- a[i] <--> a[j]
	    tmp  = a[i] ;	a[i] = a[j] ;	a[j] = tmp  ; 

	    //----- updation of i and j 
	    i++ ; j-- ;

	  } // while(1)

	  //----- recursive call for left partial series
	  if( (i - left) >= 2 ) { this->doSort( a, left, i - 1   ); }

	  //----- recursive call for right partial series
	  if( (right -j) >= 2 ) { this->doSort( a, j + 1,  right ); }

	} // doSort()


	//----- comparing functions
	//.....  Return:
	//.....  +1 if  a ">" b
	//.....  -1 if  a "<" b
	//.....   0 if  a "=" b

	//----- QuickSort<NameAndValue>::compare0()
	int compare0( NameAndValue *a , NameAndValue *b )
	{
	  //----- compare
	  if         ( a->getValue() < b->getValue() ) {
	    return  -1 ;	// *a is smaller
	  } else 	if ( a->getValue() > b->getValue() ) {
	    return   1 ;	// *b is nearer to eye than *a
	  } else {
	    return 0 ;
	  }

	} // compare0()	

	int compare1( NameAndValue *a , NameAndValue *b )
	{
	  return  (a == b ); // dummy
	}

} ; // class QuickSort < NameAndValue > 

#endif
