///////////////////////////////
/////     qsort_sq2.h      ////////
///////////////////////////////

#if !defined QSORT_SP2_H
#define      QSORT_SP2_H

#include <iostream>
#include <cstdlib>
#include "hid.h" // Polygon3D

using namespace std ;

template <>
class QuickSort < Polygon3D_p > {
		//----- mode of comparinig function
		//.....  mode = 0:  use compare0()
		//.....       = 1:  use compare1()
	int	mode ;

 public:
		//----- constructor
	QuickSort( int mode_given = 0 ) { setMode ( mode_given ); }

		//----- destructor
	~QuickSort() {;}

		//----- set mode
	void	setMode( int mode_given = 0 ) { mode = mode_given ; }

		//----- get mode at present
	int	getMode() { return mode ; }

		//----- quick sort function
	void doSort( Polygon3D_p* a, int left, int right ) 
	{
	  //----- local variables
	  int	i, j ;
	  Polygon3D_p	axis, tmp ;

	  //-----  axis
	  axis = a [ (left + right ) /2 ] ; 

	  //----- starting i and j
	  i = left ;	j = right ;

	  while(1) {
	    if        ( mode == 0 ) { 
	      while ( compare0( &a[ i ] , &axis ) == -1 ) { i++ ; }
	      while ( compare0( &a[ j ],  &axis ) == +1 ) { j-- ; }
	    } else if ( mode == 1 ) { 
	      while ( compare1( &a[ i ] , &axis ) == -1 ) { i++ ; }
	      while ( compare1( &a[ j ],  &axis ) == +1 ) { j-- ; }
	    } else {
	      cerr << "ERROR ( QuickSort::doSort() )\n";
	      cerr << "     mode = " << mode << endl ;
	      exit(1) ;
	    }

	    //----- termination condition
	    if( i >= j ) { 	break ; }

	    //----- a[i] <--> a[j]
	    tmp  = a[i] ;	a[i] = a[j] ;	a[j] = tmp  ; 

	    //----- updation of i and j 
	    i++ ; j-- ;

	  } // while(1)

	  //----- recursive call for left partial series
	  if( (i - left) >= 2 ) { this->doSort( a, left, i - 1   ); }

	  //----- recursive call for right partial series
	  if( (right -j) >= 2 ) { this->doSort( a, j + 1,  right ); }

	} // doSort()


	//----- comparing functions
	//.....  Return:
	//.....  +1 if  a ">" b
	//.....  -1 if  a "<" b
	//.....   0 if  a "=" b

	int  compare0( Polygon3D_p *a , Polygon3D_p *b )
	{
	  //----- compare
	  if         ( (*a)->zmin < (*b)->zmin ) {
	    return  -1 ;	// *a is nearer to eye than *b
	  } else 	if ( (*b)->zmin < (*a)->zmin ) {
	    return   1 ;	// *b is nearer to eye than *a
	  } else {
	    return 0 ;
	  }

	} // compare0()	

	int  compare1( Polygon3D_p *a , Polygon3D_p *b )
	{ 
	  return ( a == b ) ; // dummy
	}

} ; // class QuickSort < Polygon3D_p >


#endif


